
Redmine - Feature #703

Configurable required fields per tracker/status/role

2008-02-21 10:20 - Sven Schuchmann

Status: Closed Start date: 2008-02-21

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%
Target version: 2.1.0   
Description

Hi,

I think it would be nice to be able to configure the required fields

for an issue. I know that you can do this for custom fields, but not with

the predefined ones.

e.g.:

- I would like to have "Category" and "Assigned to" to be required

- I does not make sense to have "Tracker", "Status" and "Priority" to

be required, because you even don't have an option to leave them empty.

Related issues:

Related to Redmine - Feature #2708: Require Category Closed 2009-02-10

Related to Redmine - Feature #1091: Disabling default ticket fields per tracker Closed 2008-04-23

Related to Redmine - Feature #1919: Separate permissions for changing assigne... Closed 2008-09-18

Related to Redmine - Feature #8050: Mightful workflow field enhancement:  vis... Closed 2011-04-03

Related to Redmine - Feature #4584: Require a Target Version and Category and... Closed 2010-01-14

Has duplicate Redmine - Feature #9136: Mandatory Due Date Switch Closed 2011-08-26

Has duplicate Redmine - Feature #11055: Conditional mandatory fields Closed

Has duplicate Redmine - Feature #582: Make fields mandatory/unmandatory based... Closed

Has duplicate Redmine - Feature #2500: configure custom fields as "required f... Closed 2009-01-13

Has duplicate Redmine - Feature #1917: Required on close Closed 2008-09-18

Has duplicate Redmine - Feature #13336: Custom field option for issues: "requ... Closed

Has duplicate Redmine - Feature #10394: Implement permission "Assign users to... Closed

Has duplicate Redmine - Feature #514: Custom Field on Closing Screen Closed

Has duplicate Redmine - Feature #4670: Fine tune "New Issue" Closed 2010-01-27

Has duplicate Redmine - Feature #16716: Due Date Compulsory Closed

Associated revisions

Revision 9977 - 2012-07-15 16:12 - Jean-Philippe Lang

Workflow enhancement: editable and required fields configurable by role, tracker and status (#703, #3521).

Revision 9979 - 2012-07-15 16:19 - Jean-Philippe Lang

Removed hard-coded strings (#703, #3521).

Revision 9980 - 2012-07-15 16:19 - Jean-Philippe Lang

Fills locales (#703, #3521).

Revision 9985 - 2012-07-15 16:50 - Jean-Philippe Lang

ruby1.8 compatibility (#703, #3521).

History

#1 - 2009-06-04 19:13 - Paul Voelker

Thumbs WAY up on this request.
I think it would also be great to be able to configure what fields can be seen by what roles.  Especially when entering issues.  For example, consider

the "assigned to" field…

Right now, anyone that can enter an issue can set the "assigned to" field.  I would really prefer that "reporter" and "non member" role users not be

able to do this.

#2 - 2009-06-04 19:48 - michael bequette

This issue issue would be AMAZING!!!  It is SOOO NEEDED!!!

#3 - 2009-07-23 19:38 - Michael Chadwick

Completely agree.  We have multiple I.T. staff members and when our less-than-technically minded users try and send in tasks, we don't always see

them because they don't get assigned.  We really want to make Assigned To a required field and I cannot figure out how to do so.

Thanks for this fantastic application, though - it has changed our lives!!

#4 - 2009-07-23 19:45 - Nanda P

+1

http://www.redmine.org/issues/2708

#5 - 2009-12-06 20:05 - Nanda P

Any chance of having this feature in 0.9 ?

Configurable required fields like,

1. Assigned to:

2. Category:

#6 - 2009-12-06 20:41 - Kamil .

+1 for 0.9

(and where is the voting option by the way?!)

#7 - 2009-12-26 13:31 - Nanda P

Any body has patch for this? (make "Category:" as required field)

#8 - 2009-12-26 14:36 - Jean-Philippe Lang

The following patch makes issue category required:

Index: app/models/issue.rb

===================================================================

--- app/models/issue.rb    (revision 3238)

+++ app/models/issue.rb    (working copy)

@@ -48,7 +48,7 @@

   DONE_RATIO_OPTIONS = %w(issue_field issue_status)

-  validates_presence_of :subject, :priority, :project, :tracker, :author, :status

+  validates_presence_of :subject, :priority, :project, :tracker, :author, :status, :category

   validates_length_of :subject, :maximum => 255

   validates_inclusion_of :done_ratio, :in => 0..100

   validates_numericality_of :estimated_hours, :allow_nil => true

#9 - 2009-12-27 15:33 - Nanda P

Jean-Philippe Lang wrote:

The following patch makes issue category required:

[...]

 JP, Thanks a lot for the patch. It is working fine for new issues, but not for update (System let me blank the category value during update)

Regards,

Nanda

#10 - 2009-12-28 12:23 - Nanda P
Jean-Philippe Lang wrote:

The following patch makes issue category required:

[...]

 Required field indicator (*) is not showing up.

#11 - 2009-12-29 00:22 - Mischa The Evil

Added issue-relationship to issue #1091.

#12 - 2010-03-20 03:28 - Jose Luna

+1  I just wanted to say that we need this too (making the assigned-to field required).  I hope it's helpful for us add comments to the request, so that

you know what the community would like to see in future versions.

#13 - 2010-03-20 10:54 - Krzysztof Kowalczyk

+1

#14 - 2010-04-10 16:13 - Anton Statutov

The Jean-Philippe Lang's solution is not suitable for me because there are projects without categories. So not being familiar with ruby I made the

patch which simply selects first available category:

diff --git a/app/models/issue.rb b/app/models/issue.rb

index 8574a61..f4ebb29 100644

--- a/app/models/issue.rb

+++ b/app/models/issue.rb

@@ -211,15 +211,6 @@ class Issue < ActiveRecord::Base

   end

   def before_create

-    # default category

-    if category.nil? && project && project.issue_categories

-       project.issue_categories.each do |issue_category|

-           if category.nil?

-               self.category = issue_category

-           end

-       end

-    end

-

     # default assignment based on category

     if assigned_to.nil? && category && category.assigned_to

       self.assigned_to = category.assigned_to

 I tried to add 'default' field to category to be able to choose default category, but with no success. Maybe someone could help me to do it?

#15 - 2010-04-22 22:43 - Katrina Brinkley

Paul Voelker wrote:

Thumbs WAY up on this request.

I think it would also be great to be able to configure what fields can be seen by what roles.  Especially when entering issues.  For example,

consider the "assigned to" field…

Right now, anyone that can enter an issue can set the "assigned to" field.  I would really prefer that "reporter" and "non member" role users not

be able to do this.

 Ditto this for me. We're trying to use this as a helpdesk system as well.

#16 - 2010-07-01 14:55 - Mortitia Adams

+1

would be very important to have such a right, to dis-/enable fields for the specific roles.

This missing feature is the only reason, i can't use redmine in my company (they don't want the customer/reporter to assign tickets to specific users) :(

#17 - 2010-07-19 21:04 - Caio Cunha

Paul Voelker wrote:
Thumbs WAY up on this request.

I think it would also be great to be able to configure what fields can be seen by what roles.  Especially when entering issues.  For example,

consider the "assigned to" field…

Right now, anyone that can enter an issue can set the "assigned to" field.  I would really prefer that "reporter" and "non member" role users not

be able to do this.

 +1

Very usefull feature. When using as a helpdesk would be really nice to hide some options, in other cases, just don't let the users to update it, not even

the requirer.

By the way, after all the issue updates, what does the Redmine team says about this feature?

Thanks,

C.

#18 - 2010-08-11 23:26 - Mischa The Evil

Added relation to issue #1919 as it might be interesting in the light of the scope of this issues subject.

#19 - 2010-08-12 14:02 - Caio Cunha

Think would be nice to be able to do a "fine tuning" on view/change field permissions for roles. And also have a "default permissions settings" feature

in the scope of the category, project and overall.

This comment also (or better) applies to issue #1919.

Cheers,

CaioToOn!

#20 - 2010-08-24 15:40 - Christophe Absil

We are currently using Redmine for internal project management but I want to open Redmine to our customers. In order to create a new issue,

Redmine displays unnecessary non required fields even if we reduces the permissions of the role as much as we can. For example, "assigned to",

"Priority", ... are confusing for an external reporter. It would be great to hide/show non required default fields based on user's role.

I have read some comments in the forum and found that this issue was covering that feature. Am I wrong ? If not, does anybody have an idea when

this feature will be implemented ? Hope the answer will be "It is already there ..." ;-). Opening Redmine to our customers is part of our "end of year

targets".

Regards

Christophe Absil

#21 - 2010-09-06 09:25 - Ben Collins

+1

I am also in the process of (trying) to start using Redmine for bug tracking too. But Issues reports will come more or less from the end user

perspective, they do not know which fault it is, how long it will take it to fix it etc.

AFAIK erasing the default field is not possible, maybe one of the following options is more do able:

1. option greying them out so the issue reporter can't enter values there

2. ignoring them. the issue reporter: values can enter the values, but there will be simply not saved

3. informing the issue reporter: this value(s) are/is only a "hint" or a "suggestion"

I hope this import detail issue goes not down in the noise which surround us all.

#22 - 2010-10-18 15:28 - Sebastian Herbermann

+1

#23 - 2010-10-19 19:09 - Anonymous

+1

#24 - 2010-11-15 22:47 - Steve Overton

+1

#25 - 2011-03-02 01:28 - Glauber Matos
+1

#26 - 2011-03-25 02:16 - Brendan Abel

+1

p.s. Seriously!  This bug is over 3 years old!  You know, I did need a good reason to learn Ruby...

#27 - 2011-04-19 11:42 - Alexis U.

+1

One of these long-awaited feature...

#28 - 2011-05-02 11:43 - Johannes Schneider

+1

I was surprised this feature is not already there. It is very necessary to have the possibility to make fields mandatory/required for us. It is also

important that fields can be made invisible for customers. I read in another thread that this also is not possible by now. Please keep these features i

track! Thank you

#29 - 2011-07-30 23:02 - Seth Sandler

+1 it should be possible to make fields mandatory, optional or hidden on a per tracker-type basis. What apply to some trackers does not apply to all.

#30 - 2011-07-31 15:13 - Terence Mill

This beavhiour is described in Mightful workflow field enhancement: visible, read only and mandatory > #8050

Seth Sandler wrote:

+1 it should be possible to make fields mandatory, optional or hidden on a per tracker-type basis. What apply to some trackers does not apply to

all.

#31 - 2011-08-27 11:00 - Etienne Massip

- Category changed from Administration to Issues workflow

- Target version set to Candidate for next major release

#32 - 2011-09-01 15:01 - Aidin Abedi

+1

#33 - 2011-09-01 15:10 - Toggi Muppet

+1

#34 - 2011-09-02 20:19 - Nathanael Hansen

+1

#35 - 2011-09-25 21:50 - Shawn Duncan

+1

#36 - 2011-10-04 17:36 - Carlos Serrano

+1

#37 - 2011-10-06 13:36 - Chris Lockwood

+1

#38 - 2011-10-18 08:16 - Ahmed A

In an organization of 6000 people... this feature is absolutely required.

Excellent, excellent product otherwise.

#39 - 2011-11-02 16:23 - Beau Taub

+1

My organization would benefit from this feature request as well. We've had a number of users ask for it.

2025-05-02 5/10

https://www.redmine.org/issues/8050


#40 - 2011-11-05 02:06 - Darren Cook

+1 (unless you count my customers asking for this, then it's +5)

#41 - 2011-11-15 17:13 - Alexandre KOCH

It's very important for to remove default fields just for one tracker. Is a solution exist ?

#42 - 2011-11-15 17:14 - Alexandre KOCH

It's very important for me to remove default fields just for one tracker. Is a solution exist ?

#43 - 2011-11-24 11:35 - Octavian Susnea

This feature definitely needs to be included in redmine. I've implemented the patch by Jean-Philippe but it didn't add the asterix sign next to the label,

here is my updated patch for the Assignee field. I hope it helps:

Index: app/models/issue.rb

===================================================================

-  validates_presence_of :subject, :priority, :project, :tracker, :author, :status

+  validates_presence_of :subject, :priority, :project, :tracker, :author, :status, :assigned_to

Index: app/views/issues/_attributes.rhtml

===================================================================

-  f.select :assigned_to_id, (@issue.assignable_users.collect {|m| [m.name, m.id]}), :include_blank => true

+  f.select :assigned_to_id, (@issue.assignable_users.collect {|m| [m.name, m.id]}), :required => true, :inclu

de_blank => true 

#44 - 2012-01-04 15:49 - Lucas Castro

+1

this is something very useful to me

#45 - 2012-01-05 17:12 - Gokay Gok

+1

#46 - 2012-02-14 23:48 - Matt Groener

+1

I'd like this to be configurable per-project as well, if that wasn't clear from other requests. IE:

project-A - fixed_version is required

project-B - fixed_version is optional (the default)

etc.

#47 - 2012-02-15 13:01 - Terence Mill

Your shall check #8050 , which is more detailed how the requirements can be implemented.

#48 - 2012-02-16 19:05 - Beau Taub

Octavian, thanks for the patch, it works for me. Appreciate it.

Octavian Susnea wrote:

This feature definitely needs to be included in redmine. I've implemented the patch by Jean-Philippe but it didn't add the asterix sign next to the

label, here is my updated patch for the Assignee field. I hope it helps:

[...]

#49 - 2012-05-11 17:44 - Eric Strennen

+1

Redmine is a great product, but this feature is very important in my company. Would like to have the following default fields configurable as either

visible/enabled based on user role:

-Assignee

-Target version

-Priority

Thanks!
#50 - 2012-05-12 09:21 - Terence Mill

How could this Plugin get extended to be able to decided between view/hide, readonly, read/write and mandatory.

mandatory fields

 

{:required => true} 

 view/hide

 

 :disabled  

 readonly

??

 Which view has to be pacthed to set rules for user defined fields?

#51 - 2012-05-14 19:18 - Daniel Santos Bathke

+1

Would be very nice to configure the mandatory default fields.

#52 - 2012-06-26 23:46 - tasneem maistry

+1

#53 - 2012-07-15 18:23 - Jean-Philippe Lang

- File workflow_permissions.png added

- Subject changed from Configurable required fields to Configurable required fields per tracker/status/role

- Status changed from New to Closed

- Target version changed from Candidate for next major release to 2.1.0

- Resolution set to Fixed

Feature added. You can now configure required fields per tracker, status and role.

A new tab is added to the workflow settings to configure required standard/custom fields. This same form is used to configure read-only fields as well

(#3521):

 

2025-05-02 7/10

https://github.com/resilva/Redmine-Fields-permissions
https://www.redmine.org/issues/3521


Note that if a user has multiple roles on the same project, only fields required for all its roles are actually required.

#54 - 2012-07-16 10:40 - Luis Serrano Aranda

It's possible add the option Not visible (Required, Read Only and Not visible)

#55 - 2012-07-24 10:28 - Aleksandr Voronin

Luis Serrano Aranda wrote:

It's possible add the option Not visible (Required, Read Only and Not visible)

 +1

Some fields for some roles must be hidden.

#56 - 2012-08-22 22:01 - Jos Groot Lipman

Luis Serrano Aranda wrote:

It's possible add the option Not visible (Required, Read Only and Not visible)

 Not Visible would be a great (and simple?) addition.

Hiding field for all roles is implemented in #1091 but I really would like to hide some fields (Due date, Time spent) for certain roles only.

#57 - 2012-08-23 00:27 - Terence Mill

This will make the feature complete +1

#58 - 2012-09-04 19:59 - #  And

Me too need the feature - hide custom fields per role. But it is must be realized as additional choice - field may be required/readonly and hidden for

the clients, for example.

Jean-Philippe Lang, what you think?
#59 - 2012-09-06 19:31 - @ go2null

+1

#60 - 2012-10-15 09:40 - David Rahusen

+1

#61 - 2012-10-15 16:32 - Bruno Medeiros

Guys, this ticket is closed. Why don't you create a new one asking for that?

#62 - 2012-10-15 16:52 - David Rahusen

Bruno Medeiros wrote:

Guys, this ticket is closed. Why don't you create a new one asking for that?

 Sorry, recognized the state just after posting... :-(

In future, I will read more intensive the head information, promised! :-)

#63 - 2013-09-16 14:54 - Olivier Houdas

For people who would come to read the previous comment, it had been done with feature request #5037.

#64 - 2014-12-01 14:32 - Go MAEDA

- Has duplicate Feature #10394: Implement permission "Assign users to issues". added

#65 - 2014-12-19 11:07 - noah t

Jean-Philippe Lang wrote:

Feature added. You can now configure required fields per tracker, status and role.

A new tab is added to the workflow settings to configure required standard/custom fields. This same form is used to configure read-only fields as

well (#3521):
Note that if a user has multiple roles on the same project, only fields required for all its roles are actually required.

 I am using 2.6-stable branch from Github.

"Required" is not an option for the Subject field.

How can I remove the Subject field, or make it a not required field?  Using the above approach my only option is to make it read-only, which is

useless.

#66 - 2015-01-18 05:02 - Toshi MARUYAMA

noah t wrote:

I am using 2.6-stable branch from Github.

"Required" is not an option for the Subject field.

How can I remove the Subject field, or make it a not required field?  Using the above approach my only option is to make it read-only, which is

useless.

 Do not add note on closed issue with target version.

Please create new issue if you have feature request.

#67 - 2015-04-10 16:03 - Pedro Cainã C  Lima

I'm using the 2.6.3 version and I'm not getting permit requirement for standard field.

How can I do this?

#68 - 2016-12-24 03:11 - Go MAEDA

- Related to Feature #4584: Require a Target Version and Category and provide a default version. added

#69 - 2017-02-12 07:22 - Go MAEDA

- Has duplicate Feature #514: Custom Field on Closing Screen added

#70 - 2017-03-11 05:42 - Go MAEDA

- Has duplicate Feature #4670: Fine tune "New Issue" added

#71 - 2018-05-04 04:24 - Go MAEDA

- Has duplicate Feature #16716: Due Date Compulsory added
